# My New Essentials
#
# All packages must be inside a namespace with the
# same name as the file name.
#
# $Revision: 1.2 $

namespace eval mynews {

    # Must export at least: load, unload, goOnline, goOffline
    namespace export load unload goOnline goOffline

    # All packages must have a load routine.  This should do most
    # of the setup for the package.  Called only once.
    proc load {} {
        menu .myNewsMenu -tearoff 0
        .toolsMenu add cascade -label "Daily Essentials" -menu .myNewsMenu
        .myNewsMenu add command -label "Web Search" \
              -command {tik_show_url "DE" "http://www.aol.com/netfind/home.html"}
        .myNewsMenu add command -label "My News" \
              -command {tik_show_url "DE" "http://www.aol.com/mynews/home.adp"}
        .myNewsMenu add command -label "Stocks" \
              -command {tik_show_url "DE" "http://www.aol.com/mynews/business/home.adp"}
        .myNewsMenu add command -label "Weather" \
              -command {tik_show_url "DE" "http://www.aol.com/mynews/weather/home.adp"}
        .myNewsMenu add command -label "Scores" \
              -command {tik_show_url "DE" "http://realfans.aol.com/?MIval=rf_allscores.htm"}
        .myNewsMenu add command -label "Horoscopes" \
              -command {tik_show_url "DE" "http://www.aol.com/mynews/entertainment/horoscopes.adp"}
        .myNewsMenu add command -label "AOL Netmail" \
              -command {tik_show_url "DE" "http://www.aol.com/netmail"}
    }

    # All pacakges must have goOnline routine.  Called when the user signs
    # on, or if the user is already online when packages loaded.
    proc goOnline {} {
    }

    # All pacakges must have goOffline routine.  Called when the user signs
    # off.  NOT called when the package is unloaded.
    proc goOffline {} {
    }

    # All packages must have a unload routine.  This should remove everything 
    # the package set up.  This is called before load is called when reloading.
    proc unload {} {
        .toolsMenu delete "Daily Essentials"
        destroy .myNewsMenu
    }
}
